/*
EntryPoints

## Overview  EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.  ## Data  EntryPoints contain two types of data:   - **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction) - **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.  Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.  ## EP Batches  EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.  > EntryPoints in a batch have random hashes but it's possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).  EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).  ## Redirects  There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package entrypoints

import (
	"encoding/json"
	"fmt"
)

// EntryPointType the model 'EntryPointType'
type EntryPointType string

// List of EntryPointType
const (
	QR EntryPointType = "qr"
	NFC EntryPointType = "nfc"
	LINK EntryPointType = "link"
)

// All allowed values of EntryPointType enum
var AllowedEntryPointTypeEnumValues = []EntryPointType{
	"qr",
	"nfc",
	"link",
}

func (v *EntryPointType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := EntryPointType(value)
	for _, existing := range AllowedEntryPointTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid EntryPointType", value)
}

// NewEntryPointTypeFromValue returns a pointer to a valid EntryPointType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewEntryPointTypeFromValue(v string) (*EntryPointType, error) {
	ev := EntryPointType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for EntryPointType: valid values are %v", v, AllowedEntryPointTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v EntryPointType) IsValid() bool {
	for _, existing := range AllowedEntryPointTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to EntryPointType value
func (v EntryPointType) Ptr() *EntryPointType {
	return &v
}

type NullableEntryPointType struct {
	value *EntryPointType
	isSet bool
}

func (v NullableEntryPointType) Get() *EntryPointType {
	return v.value
}

func (v *NullableEntryPointType) Set(val *EntryPointType) {
	v.value = val
	v.isSet = true
}

func (v NullableEntryPointType) IsSet() bool {
	return v.isSet
}

func (v *NullableEntryPointType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEntryPointType(val *EntryPointType) *NullableEntryPointType {
	return &NullableEntryPointType{value: val, isSet: true}
}

func (v NullableEntryPointType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEntryPointType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

